#!/usr/bin/gnuplot

set samples 366
set angles radians
deg = pi/180
rad2deg = 180./pi
rad2min = 12.*60./pi
deg2min = 12.*60./180.
frac(x) = x-int(x)
nula2pi_(x) = frac(x/(2*pi))*2*pi
nula2pi(x) = (nula2pi_(x) < 0) ? nula2pi_(x)+2*pi : nula2pi_(x)
minpipi(x) = (nula2pi(x) > pi) ? nula2pi(x)-2*pi : nula2pi(x)
dmsd(d,m,s) = d+m/60.+s/3600.

# parametry zemske drahy a osy
e = 0.017	# excentricita drahy Zeme
eps = 23.5*deg	# sklon ekliptiky k rovniku
rok = 365.25	# dni
den_perihelia = 3
den_rovnodennosti = 81
lambda = dmsd(15, 50, 11)*deg	# zemepisna delka stanoviste

set xl "pocet dni od 1. 1. 2000"
set yl "odchylka hodinoveho uhlu / min"

set xr [1:366]

l(x) = (x - den_rovnodennosti)/rok*2*pi		# ekliptikalni delka
t(x) = atan2(sin(l(x))*cos(eps),cos(l(x)))	# hodinovy uhel

# iteracni reseni Keplerovy rovnice
M(x) = (x - den_perihelia)/rok*2*pi		# stredni anomalie
E0(x) = M(x)
E1(x) = (M(x)+e*sin(E0(x)))
E2(x) = (M(x)+e*sin(E1(x)))
E3(x) = (M(x)+e*sin(E2(x)))
E4(x) = (M(x)+e*sin(E3(x)))
E5(x) = (M(x)+e*sin(E4(x)))

E(x) = E5(x)					# excentricka anomalie

f(x) = 2*atan(sqrt((1+e)/(1-e)) * tan(E(x)/2))	# prava anomalie

p (15*deg - lambda)      * rad2min,\
  minpipi( t(x) - l(x) ) * rad2min,\
  minpipi( f(x) - M(x) ) * rad2min,\
  minpipi( 15*deg -lambda + t(x) - l(x) + f(x) - M(x) ) * rad2min,\
  "<awk '!/^#/{ i++; print i, $3; }' casova_rce_zem_delka.dat"
pa -1

set term table
set out "analema1.dat"

p minpipi( t(x) - l(x) ) * rad2min

set out "analema2.dat"

p minpipi( f(x) - M(x) ) * rad2min

########################################################################

set term x11
set out

set yl "deklinace delta / deg"

delta(x) = asin(sin(l(x))*sin(eps))		# deklinace

p delta(x)*rad2deg
pa -1

q

#eps=85

#set xr [0:360]
#set xr [0:180]
#set xr [0:2*pi]
#deg = 1

p minpipi(t(x)-l(x))
pa -1
q

