// nizbor_leve.asy
// Navrh slunecnich hodin v Nizboru (levych).
// Miroslav Broz (miroslav.broz@email.cz), Jun 17th 2007

// meritko 1:10

real u = cm/10.;
defaultpen(font("csr10")+fontsize(10));

// nacteni vstupni souboru

file in = input("ciselnik.dat");
real A[][] = dimension(in, 0, 2);

file in = input("hodin_rysky.dat");
real B[][] = dimension(in, 0, 6);	// zrus jedno odradkovani

// hodinovy ciselnik

pair z[];
guide g[];
for (int i=0; i<A.length; ++i) {
  z[i] = (A[i][0],A[i][1])*u;
}
g[0] = z[0]--z[1]--z[2]--z[3]--cycle;

pen bg = rgb(0.75,0.74,0.68);
fill(g[0], bg);
draw(g[0], bg+linewidth(1u));
real tmp = 17.5u;
g[1] = (z[0].x,0)--(z[0].x+tmp,0)--z[0]+(tmp,tmp)--z[3]+(-tmp,tmp)--(z[3].x-tmp,0)--(z[3].x,0)--z[3]--z[0]--cycle;

currentpen = linewidth(1u);
for (int i=0; i<B.length; ++i) {
  draw( scale(u) * ((B[i][1],B[i][2])--(B[i][4],B[i][5])) );
}

fill(g[1], white);
draw(g[1], white+linewidth(1u));
clip(g[0]);
draw(g[0], linewidth(0.3u));

// rimske cislice

string RomanNumeral[] = {"0", "I", "II", "III", "IV", "V", "VI", "VII", "VIII", "IX", "X", "XI", "XII", "I", "II", "III", "IV", "V", "VI", "VII", "VIII", "IX", "X", "XI", "XII" };

real rot[];
pair zz[];
for (int i=0; i<=24; ++i) {
  rot[i] = 0;
  zz[i] = (0,0);
}
rot[6] = -90;
rot[7] = -90;
rot[8] = -90;
rot[15] = 90;
rot[16] = 90;
rot[17] = 90;
zz[8] = (0,3u);
zz[11] = (-3u,0);
zz[15] = (0,5u);

g[2] = (z[0].x+0.5*tmp,0)--z[0]+0.5*(tmp,tmp)--z[3]+0.5*(-tmp,tmp)--(z[3].x-0.5*tmp,0);
pair b;
for (int i=0; i<B.length; ++i) {
  int j = floor(B[i][0]);
  b = intersectionpoint(((0,0)--(B[i][4],B[i][5])*u), g[2]);
  tmp = Tan(270 + rot[j] - degrees(b));
  write(j, tmp);
  label(rotate(rot[j]) * slant(tmp) * scale(15u/10pt) * ("{\bf " + RomanNumeral[j] + "}"), b + zz[j]);
}

// sentence

z[100] = (-62.5u,35u);
z[101] = (65u, z[100].y);
tmp = 10u/10pt;
label(scale(tmp) * "{\sc Sine Sole}", z[100], S);
label(scale(tmp) * "{\sc Nequid Sum}", z[101], S);

tmp = 3.6u/10pt;
label(scale(tmp) * "1724", point(g[0], 1), 4SE);
label(scale(tmp) * "Ren. 2007", point(g[0], 2), 4SW);

// misto pro erb (mel by byt obrazek!)

z[100] = (0u,30u);
tmp = 35;
fill(shift(z[100]) * xscale(40u) * yscale(42.5u) * ((-.5,.5)---(-.5,0)..{dir(-tmp)}(0,-.5){dir(tmp)}..(.5,0)---(.5,.5)--cycle), red);
label(scale(5u/10pt) * "ERB . 1", z[100], N, white);

// krizek pro nodus

void cross(pair b) {
  draw (shift(b)*scale(1u)*((-1,0)--(1,0)));
  draw (shift(b)*scale(1u)*((0,-1)--(0,1)));
}

file in = input("nodus.dat");
real A[][] = dimension(in, 0, 3);
currentpen = linewidth(0.3u);
cross((A[1][0], A[1][1])*u);



