#!/bin/awk -f

BEGIN{
  N=1;
  pi=3.1415926535;
  pi2 = pi/2;
  degrad=pi/180;
  ra2=-10;
  de2=-10;
}
{
  hour = substr($0,1,2);
  min = substr($0,3,2);
  sec = substr($0,5,2);
  ra = hour + min/60 + sec/3600;
  deg = substr($0,8,2);
  min = substr($0,10,2);
  sec = substr($0,12,2);
  de = deg + min/60 + sec/3600;
  if (substr($0,7,1) == "-") {
    de = -de;
  }

  ra1 = ra/12*pi;
  de1 = de*degrad;
  d = acos(sin(de1)*sin(de2) + cos(de1)*cos(de2)*cos(ra1-ra2));
#  print d;
  if (d/degrad > 1) {
    print "";
  } else if (abs(ra1-ra2) > 0.1) {
    print "";
  }

  if ((NR-1) % N == 0) {
    print ra, de;
  }
  ra2 = ra1;
  de2 = de1;
}

function acos(x) {
  if (x == 0)
    return pi2;
  else if (x > 0.9999)
    return 0;
  else if (x == -1)
    return pi;
  else 
    return atan2(x/sqrt(1-x*x),1);
}

function abs (x) {
  if (x < 0) {return -x}
  else {return x}
}

