c  reads.f - string manipulation routines
c  Miroslav Broz, miroslav.broz@email.cz, Jan 3rd 2001

c-----------------------------------------------------------------------
      real*8 function reads(s)

      implicit none
      character*(*) s
      real*8 reads2

      reads = reads2(s,':')
      return
      end

c-----------------------------------------------------------------------
      real*8 function reads2(s,sep)

      implicit none
      character*(*) s
      character sep
      integer i,j,length,sign
      real*8 x1,x2,x3,degrad,signum
      parameter(degrad=3.1415926535d0/180.0d0)

      i=index(s,sep)
      if (i.eq.0) then
        read(s,*,err=10,end=10) x1
        reads2=x1*degrad
      else
        if (index(s(1:1),'-').gt.0) then
          sign = -1
        else
          sign = +1
        endif
        j=index(s(i+1:length(s)),sep)
        if (j.eq.0) then
          read(s(1:i-1),*,err=10,end=10) x1
          read(s(i+1:length(s)),*,err=10,end=10) x2
c          reads2=signum(x1)*(abs(x1)+x2/60.0d0)*degrad
          reads2=sign*(abs(x1)+x2/60.0d0)*degrad
        else
          read(s(1:i-1),*,err=10,end=10) x1
          read(s(i+1:i+j-1),*,err=10,end=10) x2
          read(s(i+j+1:length(s)),*,err=10,end=10) x3
          reads2=sign*(abs(x1)+x2/60.0d0+x3/3600.0d0)*degrad
        endif
      endif
      return

10    continue
      write(*,20) s(1:length(s))
20    format('MIN: error reading input: ',a)
      reads2=0.0d0
      return
      end

c-----------------------------------------------------------------------
      real*8 function signum(x)
      real*8 x
      if (x.lt.0) then
        signum=-1.0d0
      else
        signum=1.0d0
      endif
      return
      end

c-----------------------------------------------------------------------
      character function signc(x)
      real*8 x
      if (x.lt.0) then
        signc='-'
      else
        signc='+'
      endif
      return
      end

c-----------------------------------------------------------------------
      subroutine reads_split(s,sep,x1,x2,x3)

      implicit none
      character*(*) s
      character sep
      integer i,j,length
      real*8 x1,x2,x3

      i=index(s,sep)
      if (i.eq.0) then
        read(s,*,err=10,end=10) x1
        x2=0.0d0
        x3=0.0d0
      else
        j=index(s(i+1:length(s)),sep)
        if (j.eq.0) then
          read(s(1:i-1),*,err=10,end=10) x1
          read(s(i+1:length(s)),*,err=10,end=10) x2
          x3=0.0d0
        else
          read(s(1:i-1),*,err=10,end=10) x1
          read(s(i+1:i+j-1),*,err=10,end=10) x2
          read(s(i+j+1:length(s)),*,err=10,end=10) x3
        endif
      endif
      return

10    continue
      write(*,20) s(1:length(s))
20    format('MIN: error reading input: ',a)
      x1=0.0d0
      x2=0.0d0
      x3=0.0d0
      return
      end

