// nizbor_prave.asy
// Navrh slunecnich hodin v Nizboru (pravych).
// Miroslav Broz (miroslav.broz@email.cz), Jun 17th 2007

// meritko 1:10

real u = cm/10.;
defaultpen(font("csr10")+fontsize(10));

// nacteni vstupnich souboru

file in = input("ciselnik.dat");
real A[][] = dimension(in, 0, 2);

file in = input("zapad_rysky.dat");
real B[][] = dimension(in, 0, 6);	// zrus odradkovani
B.delete(0);				// vynech 1. hodinu

file in = input("datum_prumet.dat");
real C[][] = dimension(in, 0, 6);

// ciselnik od Z slunce

pair z[];
guide g[];
for (int i=0; i<A.length; ++i) {
  z[i] = (A[i][0],A[i][1])*u;
}
g[0] = z[0]--z[1]--z[2]--z[3]--cycle;

fill(g[0], white);
draw(g[0], white+linewidth(1u));

currentpen = linewidth(1u);
for (int i=0; i<B.length; ++i) {
  draw( scale(u) * ((B[i][1],B[i][2])--(B[i][4],B[i][5])) );
}

// datove krivky

guide h;
for (int i=0; i<C.length; ++i) {
  h = h--((C[i][3],C[i][4])*u);
}
g[3] = subpath(h, 0, 54);	//  90 deg
g[4] = subpath(h, 55, 126);	// 180
g[5] = subpath(h, 127, 216);	// 270

real tmp = 2.5u;
g[2] = z[0]+(tmp,tmp)--z[1]+(tmp,-tmp)--z[2]+(-tmp,-tmp)--z[3]+(-tmp,tmp)--cycle;
clip(g[2]);

pen astro = rgb(0.7,0,0) + linewidth(1u) + font("astro");
//draw(g[3], astro);
draw(g[4], astro);
//draw(g[5], astro);

clip(g[2]);

pen bg = rgb(0.75,0.74,0.68);
fill(buildcycle(g[5], reverse(subpath(g[0],0,3))), bg);
fill(buildcycle(g[3], subpath(g[0],2,5)), bg);

real t1[] = intersect(g[3], subpath(g[2],0,1));
real t2[] = intersect(g[3], subpath(g[2],2,3));
real t3[] = intersect(g[5], subpath(g[2],0,1));
real t4[] = intersect(g[5], subpath(g[2],2,3));
draw(subpath(g[3],t1[0],t2[0]), astro);
draw(subpath(g[5],t3[0],t4[0]), astro);

draw(g[0], linewidth(0.3u));

tmp = 10u/10pt;
label(scale(tmp) * "A", intersectionpoint(g[4],g[0])+(0,-1u), SE, astro);
label(scale(tmp) * "G", intersectionpoint(g[4],g[0])+(0, 0u), NE, astro);
label(scale(tmp) * "D", intersectionpoint(g[3],g[0])+(0, 4u), NE, astro);
label(scale(tmp) * "J", intersectionpoint(g[5],g[0])+(0,-6u), SE, astro);

//fill(buildcycle(g[0],g[3]), gray(0.9));

// arabske cislice

string ArabicNumeral[] = {"0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13", "14", "15", "16", "17", "18", "19", "20", "21", "22", "23", "24" };

int idx[];
pair pos[];
labelmargin = 1;
for (int i=0; i<=24; ++i) {
  idx[i] = 3;
  pos[i] = S;
}
idx[13] = 0;
tmp = 1.0/sqrt(2);
pos[19] = (-tmp,-0.35);
pos[20] = (-tmp,-0.30);
pos[21] = (-tmp,-0.39);
pos[22] = (-tmp,-0.45);
pos[23] = (-tmp,-0.6);
pos[24] = (-tmp,-0.7);

for (int i=0; i<B.length; ++i) {
  int j = floor(B[i][0]);
  label(scale(10u/10pt) * (ArabicNumeral[j]), (B[i][idx[j]+1], B[i][idx[j]+2])*u, pos[j]);
}

// sentence

z[100] = (-60u,37.5u);
z[101] = (60u, z[100].y);
real tmp = 10u/10pt;
label(scale(tmp) * "{\sc Sol Cognovit}", z[100], S);
label(scale(tmp) * "{\sc Occasum Suum}", z[101], S);

tmp = 3.6u/10pt;
label(scale(tmp) * "1724 Ren. 2007", point(g[0], 0), NE);

// misto pro erb (mel by byt obrazek!)

z[100] = (0u,30u);
tmp = 35;
fill(shift(z[100]) * xscale(35u) * yscale(35u) * shift((-0.5,-0.5)) * unitsquare, blue);
label(scale(5u/10pt) * "ERB . 2", z[100], white+font("csr10"));

// krizek pro nodus

void cross(pair b) {
  draw (shift(b)*scale(1u)*((-1,0)--(1,0)));
  draw (shift(b)*scale(1u)*((0,-1)--(0,1)));
}

file in = input("nodus.dat");
real A[][] = dimension(in, 0, 3);
currentpen = linewidth(0.3u);
cross((A[0][0], A[0][1])*u);
cross((A[1][0], A[1][1])*u);



